////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

/// <summary>
/// RTCDIGAf[^z֓ǂݍ
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t ReadTag2IData(QWORD *qwData, EGTAGREF WriteTagInf, ST_ADDRINF stWAddrInf, struct MYSTATE *state)
{
	WORD		woAccessSize = stWAddrInf.woSize;						// ANZXTCY擾

	return		EgTagRead(WriteTagInf.Name, qwData, woAccessSize);		// ^OIGAf[^ɓǂݍ
}

/// <summary>
/// IGA֏ވׂ̃f[^RTCDǂݍރXbh
/// </summary>
/// <param name="state"></param>
void IDataCrtTh(struct MYSTATE *state)
{
	int32_t		result = 0;
	int32_t		iLoop = 0;
	int32_t		iIDataIdx = 0;	// IGAf[^̔zCfbNX
	ST_ADDRINF	stWAddrInf;		// Address()

	while (state->State)
	{
		if (WAIT_FAILED == WaitForRtSemaphore(state->hStICrtSem, 1, WAIT_FOREVER))	// IGAf[^v҂
		{
			SetWriteErrTag(ERR_WRITE_FAILWAIT_STIDT);			// G[^Oɏ
			state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
			UpdateIndicator(state);						// T[rXCWP[^XV
			SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
		}

		iIDataIdx = 0; // IGAf[^̃CfbNXNA
		for (iLoop = 0; iLoop < egTagRefs_OUT_Count; iLoop++) // f[^擾tagref̐[v
		{
			stWAddrInf = state->stWAddrInf[iLoop]; // TBLY^ÕAhXo

			if (!stWAddrInf.IsEnable || stWAddrInf.byType != AREATYPE_I) // Lł͂Ȃ^O(xmlɖ肠) ܂IGAł͂ȂꍇXLbv
				continue;

			result = ReadTag2IData(&state->qwTagData_I[iIDataIdx], egTagRefs_OUT[iLoop], stWAddrInf, state);	// RTCDIGAf[^z֓ǂݍ
			if (result != EDGE_SUCCESS)	// ^O͎s
			{
				SetWriteErrTag(ERR_WRITE_FAILWRITE_I);
				state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
				UpdateIndicator(state);						// T[rXCWP[^XV
				break;
			}

			iIDataIdx++; // IGAf[^̃CfbNX炷
		}

		if (state->Mode_I == MODE_I_PROCONOS) // ProConOS̏ꍇDrvInfThZ}tH҂ĂׁAZ}tH[XŏIƂʒm
		{
			ReleaseRtSemaphore(state->hEndICrtSem, 1);
		}
	}
}