#ifndef _INpLogIF_H_
#define _INpLogIF_H_


#ifdef  INpAPI_EXPORTS
#define INpAPI_API __declspec(dllexport)
#else
#define INpAPI_API __declspec(dllimport)
#endif

//-------------------------------------------------------------------------
// R}h`
//-------------------------------------------------------------------------
#define CMD_LOG_OUT		0x0000		// Oo͗v		
#define CMD_LOG_STOP	0x0001		// Oo͒~v
#define CMD_LOG_START	0x0002		// Oo͍ĊJv
#define CMD_LOG_END		0x0003		// OIviċNOȂǁj
#define CMD_LOAD_TBL	0x0004		// OݒēǍݗv

//-------------------------------------------------------------------------
// ^[R[h
//-------------------------------------------------------------------------
#define	INP_INTIME_TYPE_UNKNOWN	0						// s
#define	INP_INTIME_TYPE_REMOTE	1						// [gm[h
#define	INP_INTIME_TYPE_HYBRID	2						// nCubhm[h

#define	INP_INTIME_SERVICE_ERR	0						// INtimeT[rXG[
#define	INP_INTIME_SERVICE_OK	1						// INtimeT[rX

#define	INP_INTIME_TIME_SRV_ERR	INP_INTIME_SERVICE_ERR	// ^CT[rXG[
#define	INP_INTIME_TIME_SRV_OK	INP_INTIME_SERVICE_OK	// ^CT[rX

#define	INP_INTIME_IO_SRV_ERR	INP_INTIME_SERVICE_ERR	// h^nT[rXG[
#define	INP_INTIME_IO_SRV_OK	INP_INTIME_SERVICE_OK	// h^nT[rX

#define	INP_INTIME_IWIN32_ERR	INP_INTIME_SERVICE_ERR	// IWIN32.rtaG[
#define	INP_INTIME_IWIN32_OK	INP_INTIME_SERVICE_OK	// IWIN32.rta


//=============================================================================================
//=============================================================================================
// Xe[^XR[h
//=============================================================================================
//=============================================================================================
// G[
#define INP_E_OK				0x00000000	// 
#define INP_E_NG				0x80000001	// sB
#define INP_E_PARAM				0x80000004	// p[^słB
#define INP_E_SYSTEM			0x80000007	// VXeG[܂B
#define INP_E_TARGET			0x80000008	// wINplc܂B
											
// 																		POWER RUN ERROR
#define	INP_ST_NOTCONNECT		0x00010000	// -(ڑ)				  -	   -    -
#define	INP_ST_STOP				0x00010001	// -~                    o    -    -
#define	INP_ST_RUN				0x00010002	// -ғ					  o    o    -
#define	INP_ST_ERR				0x00010003	// -G[			  o    -    o
#define	INP_ST_RUN_ERR			0x00010004	// -ғ{G[	  o    o    o

//-------------------------------------------------------------------------
// \̒`
//-------------------------------------------------------------------------
typedef struct st_INplc_Info {
	int	iNodeNo;
	int	iINplcNo;
}INplcInfo;


//-------------------------------------------------------------------------
// ֐`
//-------------------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */   

INpAPI_API DWORD	INpLog(char *szProgramName,DWORD dwMsgID, char *szFileName, DWORD dwLine, const char *cMsg, ...);
INpAPI_API DWORD	INpCheckRemoteNode(void);						//[gm[h֐
INpAPI_API int		LogCmdSend(DWORD dwCommand);
INpAPI_API char    *INpGetCurrentPath( void );						// JgpX擾
INpAPI_API DWORD	INpCheckTimeService(DWORD dwMilliseconds);		// INtimeT[rX`FbN
INpAPI_API DWORD	INpCheckIOService(DWORD dwMilliseconds);		// INtime I/O T[rXNĂ邩̃`FbN
INpAPI_API DWORD	INpCheckINtimeService(DWORD dwMilliseconds);	// INtime T[rXNĂ邩̃`FbN
INpAPI_API DWORD	INpCheckIWIN32(DWORD dwCount);					// IWIN32.rtaNĂ邩̃`FbN

INpAPI_API int	__stdcall	INpEnum(INplcInfo *sInfoList, int iMaxListCnt);
INpAPI_API int	__stdcall	INpGetIndicator(INplcInfo *sInfo);
INpAPI_API int	__stdcall	INpRUN(INplcInfo *sInfo);
INpAPI_API int	__stdcall	INpSTOP(INplcInfo *sInfo);
INpAPI_API int	__stdcall	INpRESET(INplcInfo *sInfo);
INpAPI_API int	__stdcall	INpReboot(INplcInfo *sInfo);
INpAPI_API int	__stdcall	INpPostEvent(INplcInfo *sInfo, BYTE byEventNo);	

#ifdef __cplusplus
}
#endif /* __cplusplus */  

#endif /* _INpLogIF_H_ */
