////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ
#include "INpAPI.h"

/// <summary>
/// EdgeVXeo͎TCNXbh
/// KvΕύXsv
/// </summary>
/// <param name="state"></param>
void ThreadAutoCycle(struct MYSTATE *state)
{
	INplcInfo	sinfo = {0}; // INplc\(e0Œ)
	WORD		wstate;

	RtSleepEx(1);						// ̃gK^C~OJ[leBbNɂ낦

	while (state->State)
	{
		GetProperty(state);				// T[rXvpeB̃[h

		wstate = GetRtHandleType(state->hProConOS);	// ProConOSvZXnh^CvmF
		if (wstate == PROCESS_TYPE)					// 薳
			state->ProConOSStat = TRUE;
		else if (state->ProConOSStat == TRUE)		// G[
		{
			SetTrigErrTag(ERR_TRIG_PROCONOS_NG);	// 
			state->ProConOSStat = FALSE;			// ProConOS
			state->MAreaStat = FALSE;				// MGA
			state->IAreaStat = FALSE;				// IGA
			state->QAreaStat = FALSE;				// QGA
			EgFW_PrintLog(ServiceRealName, EG_LOG_ERR, "[ERR][%x] : ProConOS is invalid. (%d)\n", ERR_TRIG_PROCONOS_NG, __LINE__);
		}

		if (state->ProConOSStat == TRUE) // ProConOS펞Ɏs
		{
			wstate = GetRtHandleType(state->hMArea);	// MGAnh^CvmF
			if (wstate == SEGMENT_TYPE)					// 薳
				state->MAreaStat = TRUE;
			else if (state->MAreaStat == TRUE)			// G[
			{
				SetTrigErrTag(ERR_TRIG_MAREA_NG);		// 
				state->MAreaStat = FALSE;				// MGA
				EgFW_PrintLog(ServiceRealName, EG_LOG_ERR, "[ERR][%x] : M area is invalid. (%d)\n", ERR_TRIG_MAREA_NG, __LINE__);
			}

			wstate = GetRtHandleType(state->hIArea);	// IGAnh^CvmF
			if (wstate == SEGMENT_TYPE)					// 薳
				state->IAreaStat = TRUE;
			else if (state->IAreaStat == TRUE)			// G[
			{
				SetTrigErrTag(ERR_TRIG_IAREA_NG);		// 
				state->IAreaStat = FALSE;				// IGA
				EgFW_PrintLog(ServiceRealName, EG_LOG_ERR, "[ERR][%x] : I area is invalid. (%d)\n", ERR_TRIG_IAREA_NG, __LINE__);
			}

			wstate = GetRtHandleType(state->hQArea);	// QGAnh^CvmF
			if (wstate == SEGMENT_TYPE)					// 薳
				state->QAreaStat = TRUE;
			else if (state->QAreaStat == TRUE)			// G[
			{
				SetTrigErrTag(ERR_TRIG_QAREA_NG);		// 
				state->QAreaStat = FALSE;				// QGA
				EgFW_PrintLog(ServiceRealName, EG_LOG_ERR, "[ERR][%x] : Q area is invalid. (%d)\n", ERR_TRIG_QAREA_NG, __LINE__);
			}
		}

		WriteTagINplcStat();			// INplc֘A^O(ProConOS/M,I,QGA)XV

		if (state->Run)					// T[rXsԂȂ珈
		{
			switch (state->Mode_M)		// T[rX샂[hɉĕ
			{
			case MODE_M_AUTO:				// TCN[hio͋ɎXVj
				KickInput(state);
				KickOutput(state);
				break;
			case MODE_M_SEMIAUTO:			// TCNi͂̂ݎXVAo͂EM_SERVICE_UPDATEŎw߁j
				KickInput(state);
				break;
			case MODE_M_MANUAL:			// 蓮TCNio͂EM_SERVICE_UPDATEŎw߂̂Ŗj
				break;
			}
		}

		switch (state->Mode_I)		// IGA샂[hƂ̏
		{
		case MODE_I_PROCONOS:		// ProConOSRTCDǂݍ
			break;
		case MODE_I_SERVICE:							// T[rXRTCDǂݍ
			ReleaseRtSemaphore(state->hStICrtSem, 1);	// RTCDǍv
			break;
		}

		state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
		UpdateIndicator(state);						// T[rXCWP[^XV
		RtSleepEx(state->Cycle);					// TCN҂
		++state->Live;								// T[rXsJE^
	}
}