////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

/// <summary>
/// IGA݃f[^z񂩂AIGA֏
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t OutputIArea(QWORD qwData, ST_ADDRINF stWAddrInf, struct MYSTATE *state)
{
	WORD		woAccessSize = stWAddrInf.woSize;							// ANZXTCY擾
	char*		chpAccessIarea = &state->pchIArea[stWAddrInf.dwOffset];		// ANZXIGA̐擪AhX擾

	memcpy(chpAccessIarea, &qwData, woAccessSize);							// f[^IGAɃRs[

	return 0;
}

/// <summary>
/// ^OIGA֏(rbgANZX)
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t OutputIArea_Bit(QWORD qwData, ST_ADDRINF stWAddrInf, struct MYSTATE *state)
{
	BYTE	byTagBuf = 0;		// ^Oǂݍݗp
	BYTE	byIAreaBuf = 0;		// IGAǂݍݗp
	BYTE	byCalcBuf = 0;		// Zp
	BOOL	blBit;				// rbgONOFF
	int32_t ret = 0;

	memcpy(&byIAreaBuf, &state->pchIArea[stWAddrInf.dwOffset], 1);	// IGAYItZbgǂݍ

	byTagBuf = (BYTE)qwData;
	blBit = (byTagBuf >> 0) & 1;								// 0rbgڎo
	byCalcBuf = (BYTE)pow(2.0, (double)stWAddrInf.byBitPos);	// Yrbgʒu𗧂ĂԂ̒l擾

	if (blBit == FALSE)				// rbgԂ^O̓ǂݍݒlɔf
	{
		byIAreaBuf &= ~byCalcBuf;	// Ώۃrbg𗎂Ƃ
	}
	else
	{
		byIAreaBuf |= byCalcBuf;	// Ώۃrbg𗧂Ă
	}

	state->pchIArea[stWAddrInf.dwOffset] = byIAreaBuf; // IGÅYItZbgɏ߂

	return 0;
}

/// <summary>
/// IGA͗vMEIGAւ݂̏sXbh
/// </summary>
/// <param name="state"></param>
void DrvInfITh(struct MYSTATE *state)
{
	int32_t		result = 0;
	int32_t		iLoop = 0;
	int32_t		iIDataIdx = 0;	// IGAf[^̔zCfbNX
	ST_ADDRINF	stWAddrInf;		// Address()
	RTHANDLE    hResp;			// ԐM惁[{bNX

	while (state->State)
	{
		if (BAD_RTHANDLE == ReceiveRtHandle(state->hReqIMbx, WAIT_FOREVER, &hResp))	// I/OhCoIGAv҂
		{
			SetWriteErrTag(ERR_WRITE_FAILWAIT_I);				// G[^Oɏ
			state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
			UpdateIndicator(state);						// T[rXCWP[^XV
			SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
		}

		if (state->ProConOSStat == FALSE || state->IAreaStat == FALSE) // IGA܂ProConOSNG̏ꍇAsȂ
			continue;

		// ProConOSIGAf[^sꍇÃ^C~ORTCD̓ǂݍ݂sB
		if (state->Mode_I == MODE_I_PROCONOS)
		{
			ReleaseRtSemaphore(state->hStICrtSem, 1);					// RTCDǍv
			if (WAIT_FAILED == WaitForRtSemaphore(state->hEndICrtSem, 1, WAIT_FOREVER))	// RTCDǍ҂
			{
				SetWriteErrTag(ERR_WRITE_FAILWAIT_EDIDT);			// G[^Oɏ
				state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
				UpdateIndicator(state);						// T[rXCWP[^XV
				SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
			}
		}

		iIDataIdx = 0; // IGAf[^̃CfbNXNA
		for (iLoop = 0; iLoop < egTagRefs_OUT_Count; iLoop++) // f[^擾tagref̐[v
		{
			stWAddrInf = state->stWAddrInf[iLoop]; // TBLY^ÕAhXo

			if (!stWAddrInf.IsEnable || stWAddrInf.byType != AREATYPE_I) // Lł͂Ȃ^O(xmlɖ肠) ܂IGAł͂ȂꍇXLbv
				continue;

			if (stWAddrInf.byBitUse) // rbgANZX̏ꍇ
			{
				result = OutputIArea_Bit(state->qwTagData_I[iIDataIdx], stWAddrInf, state); // IGA֏o
			}
			else // rbgANZXłȂꍇ
			{
				result = OutputIArea(state->qwTagData_I[iIDataIdx], stWAddrInf, state);	// IGA֏o
			}

			iIDataIdx++; // IGAf[^̃CfbNX炷
		}

		if (FALSE == SendRtHandle(hResp, state->hRepIMsg, NULL_RTHANDLE)) // IGAXVhCoɒʒm
		{
		}
	}
}