////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

/// <summary>
/// QGA^Oւ̓ǂݍ
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t InputQArea2Tag(EGTAGREF ReadTagInf, ST_ADDRINF stRAddrInf, struct MYSTATE *state)
{
	WORD		woAccessSize = stRAddrInf.woSize;							// ANZXTCY擾
	char*		chpAccessQarea = &state->pchQArea[stRAddrInf.dwOffset];		// ANZXQGA̐擪AhX擾

	return		EgTagWrite(ReadTagInf.Name, chpAccessQarea, woAccessSize);	// QGA^O֓ǂݍ
}

/// <summary>
/// QGA^Oւ̓ǂݍ(rbgANZX)
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t InputQArea2Tag_Bit(EGTAGREF ReadTagInf, ST_ADDRINF stRAddrInf, struct MYSTATE *state)
{
	BYTE	byQAreaBuf = 0;		// QGAǂݍݗp
	BOOL	blBit;				// rbgONOFF

	byQAreaBuf = state->pchQArea[stRAddrInf.dwOffset];				// MGAǂݍ
	blBit = (byQAreaBuf >> stRAddrInf.byBitPos) & 1;				// Yrbgo																	
	return	 EgTagWrite(ReadTagInf.Name, &blBit, 1);				// Y^Oɏ
}

/// <summary>
/// EdgeVXeւ̃f[^
/// [TODO] : KvɉĒlރ^Oƒlw
/// </summary>
/// <param name="state"></param>
void DrvInfQTh(struct MYSTATE *state)
{
	int32_t		result = 0;
	int32_t		iLoop = 0;
	ST_ADDRINF	stRAddrInf;	// Address(ǂݍ)
	RTHANDLE	hResp;		// ԋp惁[{bNX

	while (state->State)
	{
		if (BAD_RTHANDLE == ReceiveRtHandle(state->hReqQMbx, WAIT_FOREVER, &hResp))	// I/OhCoQGAv҂
		{
			SetReadErrTag(ERR_READ_FAILWAIT_Q);			// G[^Oɏ
			state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
			UpdateIndicator(state);						// T[rXCWP[^XV
			SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
		}

		if (state->ProConOSStat == FALSE || state->MAreaStat == FALSE) // MGA܂ProConOSNG̏ꍇAsȂ
			continue;

		for (iLoop = 0; iLoop < egTagRefs_IN_Count; iLoop++) // f[^擾tagref̐[v
		{
			stRAddrInf = state->stRAddrInf[iLoop]; // TBLY^ÕAhXo

			if (!stRAddrInf.IsEnable || stRAddrInf.byType != AREATYPE_Q) // Lł͂Ȃ^O(xmlɖ肠) ܂QGAł͂ȂꍇXLbv
				continue;

			if (stRAddrInf.byBitUse) // rbgANZX̏ꍇ
			{
				result = InputQArea2Tag_Bit(egTagRefs_IN[iLoop], stRAddrInf, state); // QGA^O֓
				if (result != EDGE_SUCCESS)											 // ^O͎s
				{
					SetReadErrTag(ERR_READ_FAILREAD_Q);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}
			else // rbgANZXłȂꍇ
			{
				result = InputQArea2Tag(egTagRefs_IN[iLoop], stRAddrInf, state); // QGA^O֓
				if (result != EDGE_SUCCESS)										 // ^O͎s
				{
					SetReadErrTag(ERR_READ_FAILREAD_Q);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}

		}

		if (FALSE == SendRtHandle(hResp, state->hRepQMsg, NULL_RTHANDLE)) // QGAXVhCoɒʒm
		{
		}
	}
}