////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

/// <summary>
/// MGA^Oւ̓ǂݍ
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t InputMArea2Tag(EGTAGREF ReadTagInf, ST_ADDRINF stRAddrInf, struct MYSTATE *state)
{
	WORD		woAccessSize	= stRAddrInf.woSize;						// ANZXTCY擾
	char*		chpAccessMarea	= &state->pchMArea[stRAddrInf.dwOffset];	// ANZXMGA̐擪AhX擾

	return		EgTagWrite(ReadTagInf.Name, chpAccessMarea, woAccessSize);	// MGA^O֓ǂݍ
}

/// <summary>
/// MGA^Oւ̓ǂݍ(rbgANZX)
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t InputMArea2Tag_Bit(EGTAGREF ReadTagInf, ST_ADDRINF stRAddrInf, struct MYSTATE *state)
{
	BYTE	byMAreaBuf = 0;		// MGAǂݍݗp
	BOOL	blBit;				// rbgONOFF

	byMAreaBuf = state->pchMArea[stRAddrInf.dwOffset];				// MGAǂݍ
	blBit = (byMAreaBuf >> stRAddrInf.byBitPos) & 1;				// Yrbgo																	
	return	 EgTagWrite(ReadTagInf.Name, &blBit, 1);				// Y^Oɏ
}

/// <summary>
/// EdgeVXeւ̃f[^
/// [TODO] : KvɉĒlރ^Oƒlw
/// </summary>
/// <param name="state"></param>
void ThreadInService(struct MYSTATE *state)
{
	int32_t		result = 0;
	int32_t		iLoop = 0;
	ST_ADDRINF	stRAddrInf;	// Address(ǂݍ)

	while (state->State)
	{
		if (WAIT_FAILED == WaitForRtSemaphore(state->hInTrigSem, 1, WAIT_FOREVER))	// ̓^C~OgK҂
		{
			SetReadErrTag(ERR_READ_FAILWAIT);					// G[^Oɏ
			state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
			UpdateIndicator(state);						// T[rXCWP[^XV
			SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
		}

		if (state->ProConOSStat == FALSE || state->MAreaStat == FALSE) // MGA܂ProConOSNG̏ꍇAsȂ
			continue;

		for (iLoop = 0; iLoop < egTagRefs_IN_Count; iLoop++) // f[^擾tagref̐[v
		{
			stRAddrInf = state->stRAddrInf[iLoop]; // TBLY^ÕAhXo

			if (!stRAddrInf.IsEnable || stRAddrInf.byType != AREATYPE_M) // Lł͂Ȃ^O(xmlɖ肠) ܂MGAł͂ȂꍇXLbv
				continue;

			if (stRAddrInf.byBitUse) // rbgANZX̏ꍇ
			{
				result = InputMArea2Tag_Bit(egTagRefs_IN[iLoop], stRAddrInf, state); // MGA^O֓
				if (result != EDGE_SUCCESS)											 // ^O͎s
				{
					SetReadErrTag(ERR_READ_FAILREAD);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}
			else // rbgANZXłȂꍇ
			{
				result = InputMArea2Tag(egTagRefs_IN[iLoop], stRAddrInf, state); // MGA^O֓
				if (result != EDGE_SUCCESS)										 // ^O͎s
				{
					SetReadErrTag(ERR_READ_FAILREAD);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}

		}
		Increment_ReadCount(); // ǂݍ݉񐔉Z
	}
}