////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "edgeCode.h"		// RT-edge T[rXʒ`/֐wb_ǉ

/// <summary>
/// ^OMGA֏
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t OutputTag2MArea(EGTAGREF WriteTagInf, ST_ADDRINF stWAddrInf, struct MYSTATE *state)
{
	WORD		woAccessSize = stWAddrInf.woSize;							// ANZXTCY擾
	char*		chpAccessMarea = &state->pchMArea[stWAddrInf.dwOffset];		// ANZXMGA̐擪AhX擾

	return		EgTagRead(WriteTagInf.Name, chpAccessMarea, woAccessSize);	// ^OMGAɓǂݍ
}

/// <summary>
/// ^OMGA֏(rbgANZX)
/// </summary>
/// <param name="stRAddrInf"></param>
/// <returns></returns>
int32_t OutputTag2MArea_Bit(EGTAGREF WriteTagInf, ST_ADDRINF stWAddrInf, struct MYSTATE *state)
{
	BYTE	byTagBuf = 0;		// ^Oǂݍݗp
	BYTE	byMAreaBuf = 0;		// MGAǂݍݗp
	BYTE	byCalcBuf = 0;		// Zp
	BOOL	blBit;				// rbgONOFF
	int32_t ret = 0;

	memcpy(&byMAreaBuf, &state->pchMArea[stWAddrInf.dwOffset], 1);	// MGAYItZbgǂݍ

	ret = EgTagRead(WriteTagInf.Name, &byTagBuf, 1);	// Y^Oǂݍ
	if (ret != EDGE_SUCCESS)							// ^Oǂݍݎs
	{
		return ret;
	}
	blBit = (byTagBuf >> 0) & 1;								// 0rbgڎo
	byCalcBuf = (BYTE)pow(2.0, (double)stWAddrInf.byBitPos);	// Yrbgʒu𗧂ĂԂ̒l擾

	if (blBit == FALSE)				// rbgԂ^O̓ǂݍݒlɔf
	{
		byMAreaBuf &= ~byCalcBuf;	// Ώۃrbg𗎂Ƃ
	}
	else
	{
		byMAreaBuf |= byCalcBuf;	// Ώۃrbg𗧂Ă
	}

	state->pchMArea[stWAddrInf.dwOffset] = byMAreaBuf; // MGÅYItZbgɏ߂
	
	return 0;
}

/// <summary>
/// EdgeVXẽf[^o
/// [TODO] : KvɉĒlǂݍރ^Ow
/// </summary>
/// <param name="state"></param>
void ThreadOutService(struct MYSTATE *state)
{
	int32_t		result = 0;
	int32_t		iLoop = 0;
	ST_ADDRINF	stWAddrInf;	// Address(ǂݍ)

	while (state->State)
	{
		if (WAIT_FAILED == WaitForRtSemaphore(state->hOutTrigSem, 1, WAIT_FOREVER))	// ̓^C~OgK҂
		{
			SetWriteErrTag(ERR_WRITE_FAILWAIT);					// G[^Oɏ
			state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
			UpdateIndicator(state);						// T[rXCWP[^XV
			SuspendRtThread(GetRtThreadHandles(THIS_THREAD));	// Xbh̃TXyh
		}

		if (state->ProConOSStat == FALSE || state->MAreaStat == FALSE) // MGA܂ProConOSNG̏ꍇAsȂ
			continue;

		for (iLoop = 0; iLoop < egTagRefs_OUT_Count; iLoop++) // f[^擾tagref̐[v
		{
			stWAddrInf = state->stWAddrInf[iLoop]; // TBLY^ÕAhXo

			if (!stWAddrInf.IsEnable || stWAddrInf.byType != AREATYPE_M) // Lł͂Ȃ^O(xmlɖ肠) ܂MGAł͂ȂꍇXLbv
				continue;

			if (stWAddrInf.byBitUse) // rbgANZX̏ꍇ
			{
				result = OutputTag2MArea_Bit(egTagRefs_OUT[iLoop], stWAddrInf, state); // MGA^O֓
				if (result != EDGE_SUCCESS)											   // ^O͎s
				{
					SetWriteErrTag(ERR_WRITE_FAILWRITE);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}
			else // rbgANZXłȂꍇ
			{
				result = OutputTag2MArea(egTagRefs_OUT[iLoop], stWAddrInf, state);	// MGA^O֓
				if (result != EDGE_SUCCESS)											// ^O͎s
				{
					SetWriteErrTag(ERR_WRITE_FAILWRITE);
					state->Error = DecisionErrIndicator(state);	// G[CWP[^̓eXV
					UpdateIndicator(state);						// T[rXCWP[^XV
					break;
				}
			}
		}
		Increment_WriteCount(); // ݉񐔉Z
	}
}