////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
#pragma once
#include <egAPI.h>			// RT-edge system API
#include <rt.h>			// INtime Base Library

/*****************************************************************************
*
* FILE NAME:		edgeCommon.h
*
* DESCRIPTION:		T[rXʒ`E֐@wb_t@C
*
* [TODO]:			KvɉĊe`/֐̒ǉE폜EύXsĂ   
*                   SERVICENAME ͕KύXĂ
*
\*****************************************************************************/

/// //////////////////////////////////////////////////////////////////////////////
/// e`ǉ
///

/// <summary>
/// TaǵuAddressv߂\
/// </summary>
typedef struct
{
	BOOL	 IsEnable;	// Lȃf[^ǂ
	uint16_t woSize;	// f[^TCY(1,2,4)
	uint32_t dwOffset;	// oCgItZbg
	uint8_t	 byBitUse;	// rbggptO(TRUE=rbgANZX)
	uint8_t	 byBitPos;	// rbgʒu
	uint8_t  byType;	// ^Cv̔(1:MGAA2:IGAA3:QGA)
}ST_ADDRINF;

/// <summary>
/// J^O`
/// </summary>
#define CTLG_READTH			"ReadMTh"		// ǂݍ݃Xbh
#define CTLG_WRITETH		"WriteMTh"		// ݃Xbh
#define CTLG_TRIGTH			"TrigTh"		// gKXbh
#define CTLG_READSEM		"ReadMSem"		// ǂݍ݃Z}tH
#define CTLG_WRITESEM		"WriteMSem"		// ݃Z}tH
#define CTLG_PROCONOS		"ProConOS"		// ProConOSvZX
#define CTLG_MAREA			"PRO_MAREA"		// MGA
#define CTLG_IAREA			"PRO_INPUT"		// IGA
#define CTLG_QAREA			"PRO_OUTPUT"	// QGA
#define CTLG_CHKINPAPPTH	"CHKINPAPPTH"	// INplcAvP[VmFXbh
// I,QGAΉ֘A
#define CTLG_IDRVTH			"DrvInfITh"		// IGAo͏Xbh
#define CTLG_QDRVTH			"DrvInfQTh"		// QGA͏Xbh
#define CTLG_IWTH			"IDataCrtTh"	// IGAf[^Xbh
#define CTLG_QRTH			"QAreaRdTh"		// QGAǍERTCD݃Xbh
#define CTLG_REQQMBX		"ReqQMbx"		// IGA͗vt[{bNX
#define CTLG_REQIMBX		"ReqIMbx"		// QGAo͗vt[{bNX
#define CTLG_TAGDATAI		"TagData_I"		// IGAɏރ^Of[^̏
#define CTLG_STISEM			"StICrtSem"		// hGAf[^JnCxg
#define CTLG_ENDISEM		"EndICrtSem"	// hGAf[^Cxg

/// <summary>
/// ̑`
/// </summary>
#define MAXNODENAMESIZ		64			// m[hőTCY	
#define MAREASIZE			33554431	// INplc v3.0 MGATCY
#define IAREASIZE			16777214	// INplc v3.0 IGATCY
#define QAREASIZE			16777214	// INplc v3.0 QGATCY
#define AREATYPE_M			1			// MGA
#define AREATYPE_I			2			// IGA
#define AREATYPE_Q			3			// QGA
#define REPMEMSIZE			4096		// INplc RT-edge I/OhCoI,QGAv[{bNXɕԐM郁̃TCY

/// <summary>
/// T[rX INtime J^OɎgp
/// </summary>
#define	SERVICENAME			"EgINplc"						// ŒvZX́iJ^OɎgpj(INplc I/OhCoŎQƂ̈וύXȂ)

/// <summary>
/// T[rXCWP[^
/// </summary>
extern char IND_MYSERV_STATUS		[EG_MAX_TAGNAME + 1];	// T[rXN
#define		SERVICE_UP		1								// N
#define		SERVICE_DOWN	0								// ~
extern char IND_MYSERV_ERROR		[EG_MAX_TAGNAME + 1];	// T[rXG[
extern char IND_MYSERV_RUN			[EG_MAX_TAGNAME + 1];	// T[rXs
extern char IND_MYSERV_LIVE			[EG_MAX_TAGNAME + 1];	// T[rXsJE^

/// <summary>
/// T[rXvpeB^O
/// </summary>
extern char PROP_MYSERV_MODE		[EG_MAX_TAGNAME + 1];	// 샂[h
#define		DEFAULT_MODE			1
extern char PROP_MYSERV_MODE_M		[EG_MAX_TAGNAME + 1];	// MGAT[rX샂[h
#define		MODE_M_AUTO				1						// oTCN
#define		MODE_M_SEMIAUTO			2						// ̓TCN{o̓f}h
#define		MODE_M_MANUAL			3						// o̓f}h
#define		DEFAULT_M_MODE			MODE_M_AUTO
extern char PROP_MYSERV_MODE_Q		[EG_MAX_TAGNAME + 1];	// QGAT[rX샂[h
#define		DEFAULT_Q_MODE			1
extern char PROP_MYSERV_MODE_I		[EG_MAX_TAGNAME + 1];	// IGA݃f[^XV(1:T[rXCycleE2:ProConOS̎s)
#define		MODE_I_SERVICE			1						// T[rX̃TCN
#define		MODE_I_PROCONOS			2						// ProConOS̃TCN
#define		DEFAULT_I_MODE			MODE_I_PROCONOS
extern char PROP_MYSERV_CYCLE		[EG_MAX_TAGNAME + 1];	// T[rXTCN(ms)
#define		DEFAULT_CYCLE			100
#define		MAX_CYCLE				1000
#define		MIN_CYCLE				1
extern char PROP_MYSERV_PLCCHKCYCLE	[EG_MAX_TAGNAME + 1];	// PLCvO`FbNTCN(ms)
#define		DEFAULT_PLCCHKCYCLE		100
#define		MAX_PLCCHKCYCLE			1000
#define		MIN_PLCCHKCYCLE			1
extern char PROP_MYSERV_INPRIO		[EG_MAX_TAGNAME + 1];	// EdgeVXeւ̓̓T[rXXbhvCIeB
#define		DEFAULT_INPRIO			181
#define		MAX_INPRIO				254
#define		MIN_INPRIO				1
extern char PROP_MYSERV_OUTPRIO		[EG_MAX_TAGNAME + 1];	// EdgeVXȅo̓T[rXXbhvCIeB	
#define		DEFAULT_OUTPRIO			179
#define		MAX_OUTPRIO				254
#define		MIN_OUTPRIO				1
extern char PROP_MYSERV_TRGPRIO		[EG_MAX_TAGNAME + 1];	// EdgeVXẽgKXbhvCIeB	
#define		DEFAULT_TRGPRIO			175
#define		MAX_TRGPRIO				254
#define		MIN_TRGPRIO				1
extern char PROP_MYSERV_PLCCHKPRIO	[EG_MAX_TAGNAME + 1];	// PLCvO`FbNXbhvCIeB	
#define		DEFAULT_PLCCHKPRIO		196
#define		MAX_PLCCHKPRIO			254
#define		MIN_PLCCHKPRIO			1
extern char PROP_MYSERV_AUTORUN		[EG_MAX_TAGNAME + 1];	// sJnݒ
#define		AUTORUN_DISABLE			0						// 
#define		AUTORUN_ENABLE			1						// L
#define		DEFAULT_AUTORUN			AUTORUN_DISABLE
extern char PROP_MYSERV_IAREAPRIO	[EG_MAX_TAGNAME + 1];	//IGAXbhvCIeB	
#define		DEFAULT_IAREAPRIO		177
#define		MAX_IAREAPRIO			254
#define		MIN_IAREAPRIO			1
extern char PROP_MYSERV_QAREAPRIO	[EG_MAX_TAGNAME + 1];	//QGAXbhvCIeB	
#define		DEFAULT_QAREAPRIO		176
#define		MAX_QAREAPRIO			254
#define		MIN_QAREAPRIO			1
extern char PROP_MYSERV_IDATAPRIO	[EG_MAX_TAGNAME + 1];	//IGAf[^XbhvCIeB	
#define		DEFAULT_IDATAPRIO		178
#define		MAX_IDATAPRIO			254
#define		MIN_IDATAPRIO			1

/// <summary>
/// T[rX񋟃^O
/// </summary>
// Cӂ̃^Oǉ (XMLŒ`邱Ƃ𐄏)
//#define TAG_MYSERV_XXX ǉKv̏ꍇɋL
extern char TAG_MYSERV_WNUM				[EG_MAX_TAGNAME + 1];	// MGAւ̏݉
extern char TAG_MYSERV_RNUM				[EG_MAX_TAGNAME + 1];	// MGA̓ǂݍ݉
extern char TAG_MYSERV_ODWNUM			[EG_MAX_TAGNAME + 1];	// MGAւ̃If}hݔ
extern char TAG_MYSERV_ODRNUM			[EG_MAX_TAGNAME + 1];	// MGÃIf}hǂݍݔ
extern char TAG_MYSERV_INILASTERR		[EG_MAX_TAGNAME + 1];	// ōŌɔG[R[h
extern char TAG_MYSERV_INIERRCOUNT		[EG_MAX_TAGNAME + 1];	// ŔG[
extern char TAG_MYSERV_READLASTERR		[EG_MAX_TAGNAME + 1];	// ǂݍ݃XbhōŌɔG[R[h
extern char TAG_MYSERV_READERRCOUNT		[EG_MAX_TAGNAME + 1];	// ǂݍ݃XbhŔG[
extern char TAG_MYSERV_WRITELASTERR		[EG_MAX_TAGNAME + 1];	// ݃XbhōŌɔG[R[h
extern char TAG_MYSERV_WRITEERRCOUNT	[EG_MAX_TAGNAME + 1];	// ݃XbhŔG[
extern char TAG_MYSERV_TRIGLASTERR		[EG_MAX_TAGNAME + 1];	// gKXbhōŌɔG[R[h
extern char TAG_MYSERV_TRIGERRCOUNT		[EG_MAX_TAGNAME + 1];	// gKXbhŔG[
extern char TAG_MYSERV_PROCONOSSSTAT	[EG_MAX_TAGNAME + 1];	// ProConOS̏(TRUE: , FALSE:ُ)
extern char TAG_MYSERV_MAREASTAT		[EG_MAX_TAGNAME + 1];	// MGȀ(TRUE: , FALSE:ُ)
extern char TAG_MYSERV_IAREASTAT		[EG_MAX_TAGNAME + 1];	// IGȀ(TRUE: , FALSE:ُ)
extern char TAG_MYSERV_QAREASTAT		[EG_MAX_TAGNAME + 1];	// QGȀ(TRUE: , FALSE:ُ)
extern char TAG_MYSERV_PLCINDRUNSTAT	[EG_MAX_TAGNAME + 1];	// INplcAvP[VsԁiINpGetIndicator()߂lj
extern char TAG_MYSERV_PLCINDRUN		[EG_MAX_TAGNAME + 1];	// INplcAvP[VsL
extern char TAG_MYSERV_PLCINDERR		[EG_MAX_TAGNAME + 1];	// INplcAvP[VG[L
extern char TAG_MYSERV_LASTERR			[EG_MAX_TAGNAME + 1];	// ŌɔG[R[h

/// <summary>
/// T[rXŗLbZ[W
/// </summary>
#define INPLC_CMD_BASENUM		20000						// EgINplc̃R}h̃x[Xԍ
#define INPLC_REQ_READ_CMD		INPLC_CMD_BASENUM + 0		// ǂݍݗv
#define INPLC_REQ_WRITE_CMD		INPLC_CMD_BASENUM + 1		// ݗv

/// <summary>
/// T[rX
/// </summary>
typedef struct MYSTATE
{
	bool		State;						// CWP[^.GbWVXeڑ
	bool		Run;						// CWP[^.T[rXs
	bool		Error;						// CWP[^.T[rXُ
	uint32_t	Live;						// CWP[^.T[rXsJE^
	uint64_t	StartTime;					// CWP[^.T[rXJñ^CX^v

	uint8_t		Mode;						// vpeB.gp
	uint8_t		Mode_M;						// vpeB.T[rXs[h
	uint8_t		Mode_I;						// vpeB.IGAf[^̍XV(RTCDǍ)[h
	uint8_t		Mode_Q;						// vpeB.gp
	uint32_t	Cycle;						// vpeB.T[rXsTCN(ms)
	uint32_t	PlcChkCycle;				// vpeB.PLCvO`FbNTCN(ms)
	uint8_t		TrigPriority;				// vpeB.T[rX(gK)vCIeB
	uint8_t		InPriority;					// vpeB.T[rX()vCIeB
	uint8_t		OutPriority;				// vpeB.T[rX(o)vCIeB
	uint8_t		PlcChkPriority;				// vpeB.PLCvO`FbNvCIeB
	uint8_t		IAreaThPriority;			// vpeB.hGA͏XbhvCIeB
	uint8_t		IDataPriority;				// vpeB.hGAf[^XbhvCIeB
	uint8_t		QAreaThPriority;			// vpeB.QGAo͏XbhvCIeB
	bool		AutoRun;					// vpeB.Jnsݒ(TRUE:L , FALSE:)

	RTHANDLE	hInTrigSem;					// MGA̓T[rXgKZ}tHnh
	RTHANDLE	hOutTrigSem;				// MGAo̓T[rXgKZ}tHnh
	RTHANDLE	hProConOS;					// ProConOS̃vZXnh
	RTHANDLE	hMArea;						// MGÃnh
	RTHANDLE	hIArea;						// IGÃnh
	RTHANDLE	hQArea;						// QGÃnh
	RTHANDLE	hRepIMsg;					// IGAvMBXԐMpnh
	RTHANDLE	hRepQMsg;					// QGAvMBXԐMpnh
	RTHANDLE	hReqIMbx;					// IGAvMBX
	RTHANDLE	hReqQMbx;					// QGAvMBX
	RTHANDLE	hStICrtSem;					// IGA݃f[^JnZ}tH
	RTHANDLE	hEndICrtSem;				// IGA݃f[^IZ}tH

	char		*pchMArea;					// MGÃAhX
	char		*pchIArea;					// IGÃAhX
	char		*pchQArea;					// QGÃAhX
	char		*pchRepIMsg;				// IGAvMBXԐMp
	char		*pchRepQMsg;				// QGAvMBXԐMp

	uint32_t	WNum;						// MGAւ̏݉
	uint32_t	RNum;						// MGA̓ǂݍ݉
	uint32_t	OdWNum;						// MGAւ̃If}hݔ
	uint32_t	OdRNum;						// MGÃIf}hǂݍݔ
	uint32_t	IniLastErr;					// ōŌɔG[R[h
	uint32_t	IniErrCount;				// ŔG[
	uint32_t	ReadLastErr;				// ǂݍ݃XbhōŌɔG[R[h
	uint32_t	ReadErrCount;				// ǂݍ݃XbhŔG[
	uint32_t	WriteLastErr;				// ݃XbhōŌɔG[R[h
	uint32_t	WriteErrCount;				// ݃XbhŔG[
	uint32_t	TrigLastErr;				// gKXbhōŌɔG[R[h
	uint32_t	TrigErrCount;				// gKXbhŔG[
	bool		ProConOSStat;				// ProConOS̏(TRUE: , FALSE:ُ)
	bool		MAreaStat;					// MGȀ(TRUE: , FALSE:ُ)
	bool		IAreaStat;					// IGȀ(TRUE: , FALSE:ُ)
	bool		QAreaStat;					// QGȀ(TRUE: , FALSE:ُ)
	int32_t		PLCIndRunStat;				// INplcAvP[VsԁiINpGetIndicator()߂lj
	bool		PLCIndRun;					// INplcAvP[VsL
	bool		PLCIndErr;					// INplcAvP[VG[L
	uint32_t	LastErr;					// ŏIG[R[h
	ST_ADDRINF  *stRAddrInf;				// TagRef_INAddressTBL
	ST_ADDRINF  *stWAddrInf;				// TagRef_OUTAddressTBL
	QWORD		*qwTagData_I;				// IGAւ̏݃f[^z
	uint32_t	dwIAreaTagNum;				// IGA^OiTagData_Iz̃TCY߂Ŏgpj
} EgState;

EgState MyState;				// O[oϐƂēo^

/// <summary>
/// T[rX֐ 
/// </summary>
extern void ThreadAutoCycle(struct MYSTATE *state); 	
extern void ThreadInService(struct MYSTATE *state); 	
extern void ThreadOutService(struct MYSTATE *state); 	
extern void KickInput(struct MYSTATE *state); 			
extern void KickOutput(struct MYSTATE *state);
extern void ChkINpAppTh(struct MYSTATE *state);
extern void DrvInfITh(struct MYSTATE *state);
extern void DrvInfQTh(struct MYSTATE *state);
extern void IDataCrtTh(struct MYSTATE *state);
extern int32_t CreateServiceTags(struct MYSTATE *state);
extern int32_t UpdateIndicator(struct MYSTATE *state); 	
extern int32_t GetProperty(struct MYSTATE *state); 		
extern int32_t StartService(struct MYSTATE *state); 	
extern int32_t PauseService(struct MYSTATE *state); 	
extern int32_t InitService(struct MYSTATE *state); 		
extern int32_t KillService(struct MYSTATE *state); 		
extern void WarningMsg(int32_t position, int32_t reason);
extern void fnLog(const char* pServiceName, const char* pMode, const char * _Format, ...);
extern void fnRun(BOOL isTrue);
extern void WriteTagINplcStat(void);
extern void SetIniErrTag(DWORD ErrCode);
extern void SetReadErrTag(DWORD ErrCode);
extern void SetWriteErrTag(DWORD ErrCode);
extern void SetTrigErrTag(DWORD ErrCode);
extern void Increment_WriteReqCount(void);
extern void Increment_ReadReqCount(void);
extern void Increment_ReadCount(void);
extern void Increment_WriteCount(void);
extern BOOL DecisionErrIndicator(struct MYSTATE *state);
#define WARN(reason)	WarningMsg(__LINE__,(reason))
#define Log$(pServiceName, pMode, MSG, ...)	fnLog(pServiceName, pMode, MSG",%s,%05d", __VA_ARGS__, __FILE_NAME__, __LINE__)

/// <summary>
/// ֐G[`
/// </summary>
#define ERR_OK						0x00000000  // G[
#define ERR_INI_MAPMAREA			0x10000002  // MGA Maps
#define ERR_INI_ALLOCMEM			0x10000003  // Imێs
#define ERR_INI_PROCONOS_NG			0x10000004  // ProConOSN
#define ERR_INI_MAREA_NG			0x10000005  // MGAN
#define ERR_INI_IAREA_NG			0x10000006  // IGAN
#define ERR_INI_QAREA_NG			0x10000007  // QGAN
#define ERR_INI_MAPIAREA			0x10000008  // IGA Maps
#define ERR_INI_MAPQAREA			0x10000009  // QGA Maps
#define ERR_INI_CREATEOBJ			0x1000000A  // IuWFNgs
#define ERR_INI_ADDR_UNDEFINED		0x11000001  // TAGAddress` 
#define ERR_INI_ADDR_NAMEUNDEFINED	0x11000002  // TAGName`
#define ERR_INI_ADDR_SIZEPREFIX		0x11000003  // TAGAddress̃TCYړꂪ
#define ERR_INI_ADDR_BYTEOFFSET		0x11000004  // TAGAddress̃oCgItZbg
#define ERR_INI_ADDR_BITPOS			0x11000005  // TAGAddress̃rbgʒu
#define ERR_TRIG_PROCONOS_NG		0x20000001  // ProConOSԕs
#define ERR_TRIG_MAREA_NG			0x20000002  // MAreaԕs
#define ERR_TRIG_IAREA_NG			0x20000004  // IAreaԕs
#define ERR_TRIG_QAREA_NG			0x20000005  // QAreaԕs
#define ERR_READ_FAILREAD			0x30000001  // ^O̓ǂݍݎs
#define ERR_READ_FAILWAIT			0x30000002  // ǂݍݑҋ@s
#define ERR_READ_FAILWAIT_Q			0x30000003  // QGAǂݍݑҋ@s
#define ERR_READ_FAILREAD_Q			0x30000004  // QGA̓ǂݍݎs
#define	ERR_WRITE_FAILWRITE			0x40000001  // ^Ȍݎs
#define	ERR_WRITE_FAILWAIT			0x40000002  // ݑҋ@s
#define	ERR_WRITE_FAILWAIT_I		0x40000003  // IGAݑҋ@s
#define	ERR_WRITE_FAILWAIT_STIDT	0x40000004  // IGA݃f[^vҋ@s
#define	ERR_WRITE_FAILWAIT_EDIDT	0x40000005  // IGA݃f[^ҋ@s
#define	ERR_WRITE_FAILWRITE_I		0x40000006  // IGȀݎs

///
/// e`I
//////////////////////////////////////////////////////////////////////////////